from unittest.mock import patch

from gso.services.lso_client import _execute_playbook


@patch("gso.services.lso_client.requests.post")
def test_replace_unicode_in_lso_call_success(mock_post):
    extra_vars = {
        "deployment_description": "I am going to deploy the best GÉANT service EVER!!",
        "email": "goat@géant.org",
        "translations": {"ja": "ジェアントのスゴイなサービスをデプロイする"},
    }

    expected_parameters = {
        "playbook_name": "playbook.yaml",
        "inventory": {},
        "callback": "http://gso-api:9000/api/callback_route",
        "extra_vars": {
            "deployment_description": "I am going to deploy the best GEANT service EVER!!",
            "email": "goat@geant.org",
            "translations": {"ja": "zieantonosugoinasa-bisuwodepuroisuru"},
        },
    }

    execute_playbook = _execute_playbook.__wrapped__
    execute_playbook("playbook.yaml", "/api/callback_route", {}, extra_vars)

    mock_post.assert_called_once_with("https://localhost:44444/api/playbook", json=expected_parameters, timeout=10)
